#pragma once


#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>
#include "MyArt.h"
#include "MyResizer.h"

#include "MyEdit.h"
#include "MyEditBox.h"

#include "MyData.h"
#include "MyMenu.h"

#include "systray.h"

#include "MyOptions.h"

#include "MyPassword.h"

#include "resource.h"



class CMainWindow : public CFrameWnd
{
public:
	CMainWindow()
	{
		char szTitle[] = "Note-It from www.xbdev.net.net";

		//LPCTSTR MyClass = AfxRegisterWndClass(CS_VREDRAW|CS_HREDRAW, 
		//            AfxGetApp()->LoadStandardCursor(IDC_ARROW),
		//	(HBRUSH)::GetStockObject(WHITE_BRUSH), AfxGetApp()->LoadStandardIcon(IDI_APPLICATION) );


		Create(NULL, szTitle, /*WS_POPUPWINDOW */ WS_POPUP, CRect(100,100,300,300), NULL, NULL, WS_EX_TOPMOST | WS_EX_TOOLWINDOW);
		
	};
public:
	CMyArt     m_topLeft;
	CMyResizer m_resizer;
	CMyArt     m_topBar;
	
	//CMyEdit     m_MyEdit;
	CMyEditBox m_MyEditBox;

	CMyData     m_MyData;

	csystray    m_MySysTray;
	CMyMenu		m_Menu;

	CBitmapButton  m_ButtonClose;

public:
	DECLARE_MESSAGE_MAP()
public:
	bool RgnFromBitmap(CRgn* m_Rgn)
	{
		UINT ResourceIDBitmap = IDB_BITMAP_LEFTCORNER;
		CClientDC dc(this);

		CDC              memDC;
		CBitmap         cBitmap;
		CBitmap*        pOldMemBmp = NULL;
		COLORREF        col;
		CRect            cRect;
		int              x, y;
		CRgn              rgnTemp;

		GetWindowRect(&cRect);

		cBitmap.LoadBitmap(ResourceIDBitmap);
		memDC.CreateCompatibleDC(&dc);
		pOldMemBmp = memDC.SelectObject(&cBitmap);

		m_Rgn->CreateRectRgn(0, 0, cRect.Width(), cRect.Height());
		for(x=0; x<=cRect.Width(); x++)
		{
			for(y=0; y<=cRect.Height(); y++)
			{
				col = memDC.GetPixel(x, y); // transparent colour is black
				if(col == 0)
				{
					rgnTemp.CreateRectRgn(x, y, x+1, y+1);
					m_Rgn->CombineRgn(m_Rgn, &rgnTemp, RGN_XOR);//RGN_XOR);
					rgnTemp.DeleteObject();     
				}
			}
		}
		if (pOldMemBmp) memDC.SelectObject(pOldMemBmp);
	
		//SetWindowRgn((HRGN)m_Rgn, TRUE);

		return 1;
	}

	afx_msg int OnCreate(LPCREATESTRUCT l)
	{
		CFrameWnd::OnCreate(l);

		CRgn rgn; 
		CRect rect; 
		GetWindowRect(&rect); 
		ScreenToClient(&rect);
		int x1   = rect.left;
		int y1    = rect.top;
		int x2  = rect.right;
		int y2 = rect.bottom;

		
		//rgn.CreateRoundRectRgn(x1+5, y1+5, x2+5, y2+5, 0, 0); 
		
		//---rgn.CreateRectRgn(x1+4, y1+4, x2, y2);
		rgn.CreateRectRgn(x1+4, y1+4, x2, y2);
		//rgn.OffsetRgn(4,4);

		CPoint pp[3];
		pp[0].x = 0;  pp[0].y = 0;
		pp[1].x = 0;  pp[1].y = 50;
		pp[2].x = 50;  pp[2].y = 0;

		CRgn LeftCorner;
		LeftCorner.CreatePolygonRgn(pp, 3, ALTERNATE);//WINDING);
		
		
		//CRgn Result;
		//Result.CreateRectRgn(x1, y1, x2, y2);
		//Result.CombineRgn(&rgn, &LeftCorner, RGN_AND);
		//rgn.CombineRgn(&rgn, &LeftCorner, RGN_XOR);

		//SetWindowRgn(rgn, TRUE); 

		CRgn rr;
		RgnFromBitmap(&rr);
		rr.OffsetRgn(4,4);
		rgn.CombineRgn(&rgn, &rr, RGN_AND);
		SetWindowRgn(rgn, TRUE);
		
		m_topLeft.Create(_T("STATIC"), "Corner",  WS_VISIBLE, CRect(0,0,20,20), this, 505);
		m_topLeft.SetImage(IDB_BITMAP_LEFTCORNER, 20, 20);

		//LPCTSTR MyClass = AfxRegisterWndClass(CS_VREDRAW|CS_HREDRAW, AfxGetApp()->LoadStandardCursor(IDC_ARROW),
		//	(HBRUSH)::GetStockObject(WHITE_BRUSH), AfxGetApp()->LoadStandardIcon(IDI_APPLICATION) );

		//m_resizer.Create(MyClass, "Resizer",  WS_VISIBLE, CRect(50,50,60,60), this, 507);
		m_resizer.Create(_T("STATIC"), "Resizer",  WS_VISIBLE, CRect(50,50,60,60), this, 507);
		m_resizer.SetImage(IDB_RESIZER, 15, 15);

		//m_resizer.MoveWindow(rect.right-26,rect.bottom-26,5,5);
		m_resizer.MoveWindow(rect.right-15-6,rect.bottom-15-6,15,15);

		m_bLButtonDown = false;
		m_bResizer = false;

		CRect ClientArea;
		GetClientRect(&ClientArea);
		CRect cEditPos = CRect( 10 , m_topLeft.m_Height+5, 
			ClientArea.Width()-5 ,ClientArea.Height()-5-m_resizer.m_Height);

		/*
		m_MyEdit.Create( ES_MULTILINE | WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_AUTOVSCROLL | ES_AUTOHSCROLL  ,
						cEditPos, this, 414);
		m_MyEdit.SetBackColour(RGB(255,255,0));
		m_MyEdit.SetWindowText("Notes:");
		*/

		m_MyEditBox.Create(NULL, "Edit Box", WS_CHILD|WS_VISIBLE, cEditPos, this, 414);
		m_MyEditBox.SetWindowText("Notes Box:");

		m_topBar.Create(_T("STATIC"), "TopBar", WS_VISIBLE, CRect(50, 2, 20, 150), this, 555);
		m_topBar.SetImage(IDB_TOPBAR, 10, 10);
		
		CRect topBarArea = CRect( m_topLeft.m_Width +3, 4,
			ClientArea.Width()-20,  m_topBar.m_Width);
		m_topBar.MoveWindow( &topBarArea );

		CRect butPos = CRect( ClientArea.Width()-15,  5,
			                    ClientArea.Width()-5, 15);
		m_ButtonClose.Create("", WS_CHILD|WS_VISIBLE|BS_OWNERDRAW, 
					butPos, this, CM_XCROSSBUTTON);
		m_ButtonClose.LoadBitmaps(IDB_CLOSE_UP, IDB_CLOSE_DOWN);


		m_MyData.SetData(& m_MyEditBox.m_MyEdit);
		m_MyData.LoadData();


		m_Menu.CreatePopupMenu();

		//m_Menu.AppendMenu(MF_OWNERDRAW|MF_BYPOSITION , CM_ABOUT, "About");
		
		m_Menu.AppendMyMenu(CM_ABOUT, IDI_ABOUT, "About");
		m_Menu.AppendMenu(MF_SEPARATOR);
		m_Menu.AppendMyMenu(CM_OPTIONS, IDI_OPTIONS, "Options");

		m_Menu.AppendMyMenu(CM_HIDE, IDI_HIDE, "Hide");
		m_Menu.AppendMyMenu(CM_SAVE, IDI_SAVE, "Save");
		m_Menu.AppendMenu(MF_SEPARATOR);
		m_Menu.AppendMyMenu(CM_CLOSE, IDI_EXIT, "Exit");
	
		m_Menu.ModifyMyMenu(2, CM_HIDE, IDI_HIDE, "Hide");

		m_MySysTray.create(this, 666, "NoteIt by Ben Kenwright (www.xbdev.net)", AfxGetApp()->LoadIcon(IDI_NOTEIT), &m_Menu);
		m_MySysTray.setdefault(CM_SHOW);

		CRect Desk;
		::GetWindowRect(NULL, &Desk);
		MoveWindow(100 ,100, 300, 200, TRUE);
		Sizing();

		ShowWindow(SW_SHOW);

		if(m_MyData.m_MyCommandLine.b_m == true)
			CmHide();

		return 1;
	}


	afx_msg BOOL OnEraseBkgnd(CDC *pDC)
	{
		CRect rect;
		GetClientRect(rect);
		pDC->FillRect(rect, &CBrush(RGB(255,255,0)));

		
		//CFrameWnd::OnEraseBkgnd(pDC);
		return 1;
	}
	afx_msg void OnPaint()
	{
		static bool bFirstTime = true;
		if( bFirstTime)
		{
			if(m_MyData.m_MyCommandLine.b_m == true)
				CmHide();

			bFirstTime = false;
			return;
		}

		CPaintDC pDC(this);
		m_topLeft.Invalidate();

		CRect rect;
		GetClientRect(rect);

		int r = rect.right-1;
		int b = rect.bottom-1;
		int t = 2;
		int l = 2;
		CPoint pp[5];
		pp[0]	= CPoint(l,   t);
		pp[1]   = CPoint(r,   t);
		pp[2]   = CPoint(r,   b);
		pp[3]   = CPoint(l,   b);
		pp[4]   = CPoint(l,   t);

		pDC.Polyline(pp, 5);

		//m_topLeft.InvalidateRect(rect, TRUE);
		//m_topLeft.UpdateWindow();
	}
	
	afx_msg void OnRButtonDown(UINT n, CPoint p)
	{
		CPoint pos;
		GetCursorPos(&pos);
		this->SetForegroundWindow();
		
		
		m_Menu.TrackPopupMenu(TPM_RIGHTBUTTON, pos.x, pos.y, this);

		this->PostMessage(WM_NULL,0,0);
		
		CFrameWnd::OnRButtonDown(n, p);
	}

	bool m_bLButtonDown;
	bool m_bResizer;
	CPoint m_lastpoint;
	afx_msg void OnMouseMove(UINT n, CPoint p)
	{
		if( MK_LBUTTON == false)
			m_bLButtonDown = false;

		CRect c1, c2;
		GetClientRect(&c1);
		ClientToScreen(&c1);
		m_resizer.GetWindowRect(&c2);

		CPoint p1 = p;
		ClientToScreen(&p1);

		if( c2.PtInRect(p1) )
				SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZENWSE));

		if( m_bLButtonDown == true)
		{

			CRect cR;
			m_resizer.GetClientRect(&cR);
			ClientToScreen(&cR);

			CRect r;
			GetClientRect(&r);
			ClientToScreen(&r);
			ClientToScreen(&p);

			CRect minSize;
			GetClientRect(&minSize);
			
			if( m_bResizer && ((minSize.right - (m_lastpoint.x - p.x) ) > 150) &&
				              ((minSize.bottom - (m_lastpoint.y - p.y) ) > 150) )
			{
				CPoint pp;
				//pp = p;
				//ScreenToClient(&pp);
				//MessageBox("Inside");
				pp = m_lastpoint - p;
				//ScreenToClient(&pp);

				m_resizer.MoveWindow(r.right - cR.right - pp.x - 4, 
					r.bottom - cR.bottom - pp.y - 4,
					                  m_resizer.m_Width,m_resizer.m_Height);

				AfxGetMainWnd()->GetWindowRect(&r);
				AfxGetMainWnd()->MoveWindow(
					r.left /*- (m_lastpoint.x - p.x)*/,
					r.top /*- (m_lastpoint.y - p.y)*/,
					r.Width() - (m_lastpoint.x - p.x),
					r.Height() -(m_lastpoint.y - p.y) );
				m_lastpoint = p;

				{
						CRgn rgn; 
						CRect rect; 
						GetWindowRect(&rect); 
						ScreenToClient(&rect);
						int x1   = rect.left;
						int y1    = rect.top;
						int x2  = rect.right;
						int y2 = rect.bottom;

						rgn.CreateRectRgn(x1+4, y1+4, x2, y2);

								CPoint pp[3];
						pp[0].x = 0;  pp[0].y = 0;
						pp[1].x = 0;  pp[1].y = 50;
						pp[2].x = 50;  pp[2].y = 0;

						CRgn LeftCorner;
						LeftCorner.CreatePolygonRgn(pp, 3, ALTERNATE);//WINDING);

						CRgn rr;
						RgnFromBitmap(&rr);
						rr.OffsetRgn(4,4);
						rgn.CombineRgn(&rgn, &rr, RGN_AND);
						SetWindowRgn(rgn, TRUE);
				}

				Sizing();
			}
		}

		CFrameWnd::OnMouseMove(n, p);
	}

	afx_msg void MoveWindow(int x, int y, int nWidth, int nHeight, BOOL bRepaint)
	{
		CFrameWnd::MoveWindow(x, y, nWidth, nHeight, bRepaint);

				CRect rect;
				GetWindowRect(&rect); 
				ScreenToClient(&rect);

				m_resizer.MoveWindow(rect.right-15-6,rect.bottom-15-6,15,15);

				{
						CRgn rgn; 
						CRect rect; 
						GetWindowRect(&rect); 
						ScreenToClient(&rect);
						int x1   = rect.left;
						int y1    = rect.top;
						int x2  = rect.right;
						int y2 = rect.bottom;

						rgn.CreateRectRgn(x1+4, y1+4, x2, y2);

								CPoint pp[3];
						pp[0].x = 0;  pp[0].y = 0;
						pp[1].x = 0;  pp[1].y = 50;
						pp[2].x = 50;  pp[2].y = 0;

						CRgn LeftCorner;
						LeftCorner.CreatePolygonRgn(pp, 3, ALTERNATE);//WINDING);

						CRgn rr;
						RgnFromBitmap(&rr);
						rr.OffsetRgn(4,4);
						rgn.CombineRgn(&rgn, &rr, RGN_AND);
						SetWindowRgn(rgn, TRUE);
				}

				Sizing();


	}

	void Sizing()
	{
		CRect ClientArea;
		GetClientRect(&ClientArea);
		CRect cEditPos = CRect( 
						10 , 
						m_topLeft.m_Height+5, 
						
						ClientArea.Width()-5 ,
						ClientArea.Height()-5-m_resizer.m_Height);
					
		//m_MyEdit.MoveWindow(cEditPos);
		m_MyEditBox.MoveWindow(cEditPos);

		CRect topBarArea = CRect( m_topLeft.m_Width +3, 4,
		ClientArea.Width()-20,  m_topBar.m_Width);
		m_topBar.MoveWindow( &topBarArea );

		CRect butPos = CRect( ClientArea.Width()-15,  5,
			                    ClientArea.Width()-5, 15);
		m_ButtonClose.MoveWindow(butPos);
	}


	afx_msg void OnLButtonDown(UINT n, CPoint p)
	{
		CRect cR;
		m_resizer.GetWindowRect(&cR);
		CRect r;
		GetClientRect(&r);
		ClientToScreen(&r);
		ClientToScreen(&p);
		m_lastpoint = p;
		if( cR.PtInRect(p) )
		{
			m_bResizer = true;
			//GetCapture();
			SetCapture();
			//AfxGetApp()->LoadStandardCursor(IDC_ARROW)
			SetCursor(AfxGetApp()->LoadStandardCursor(IDC_CROSS));
			
		}
		else
		{
			//ReleaseCapture(); //This is not compulsory
			POINT pt; 
			GetCursorPos(&pt);
			POINTS pts = {pt.x, pt.y}; 
			::SendMessage(m_hWnd,WM_NCLBUTTONDOWN,HTCAPTION,(LPARAM)&pts);
		
			m_bResizer = false;

		}
		m_bLButtonDown = true;


		CFrameWnd::OnLButtonDown(n, p);
	}
	afx_msg void OnLButtonUp(UINT n, CPoint p)
	{
		
		m_bLButtonDown = false;
		m_bResizer = false;
		ReleaseCapture();

		CFrameWnd::OnLButtonUp(n, p);
	}

	afx_msg void OnNcMouseMove(UINT nHitTest,CPoint point )
	{
		m_bLButtonDown = false;
		m_bResizer = false;

		CFrameWnd::OnNcMouseMove(nHitTest, point);
	}


	afx_msg void OnSize(UINT n, int cx, int cy)
	{

		CFrameWnd::OnSize(n, cy, cy);
	}

	afx_msg void CmCrossButton()
	{
		CmHide();
	}
	afx_msg void CmClose()
	{
		m_MyData.SaveData();

		m_MySysTray.remove();
		// Save DATA
		PostQuitMessage(0);
	}

	afx_msg void CmOptions()
	{
		CMyOptions a;
		a.Show(&m_MyData);
	}
	

	afx_msg void CmSave()
	{
		m_MyData.SaveData();
	}

	afx_msg void CmHide()
	{
		m_Menu.ModifyMyMenu(2, CM_SHOW, IDI_SHOW, "Show");
		ShowWindow(SW_HIDE);
	}

	afx_msg void CmAbout()
	{
		CDialog About(IDD_ABOUT, this );//GetDesktopWindow());
		About.DoModal();
	}

	afx_msg void CmShow()
	{
		
		if( m_MyData.m_Options.m_Data[0].bValue )
		{
			// Ask for the password;
			char szPassword[100];
			strcpy(szPassword, m_MyData.m_Options.m_Data[2].szData);

			

			CMyPassword a;
			a.DoModal(); // pass = 0 for faile, 1 for correct

			if( strncmp(szPassword, a.m_szPassword, strlen(a.m_szPassword)) == 0)
			{
				;
			}
			else
			{
				MessageBeep(8);
				return;
			}
			
				

		}
		
		m_Menu.ModifyMyMenu(2, CM_HIDE, IDI_HIDE, "Hide");
		ShowWindow(SW_RESTORE);
		
	}

};




