#pragma once

#include "afxwin.h"
#include "resource.h"


class CMyMenuData
{
public:
	UINT ICON_RESOURCE_ID;
	UINT ID;
	char str[40];
};

class CMyMenu : public CMenu
{
public:
	CMyMenu(void){ m_NumItems=0;};
	virtual ~CMyMenu(void){};
	
	int m_NumItems;
	CMyMenuData m_ItemData[20];
public:
	virtual void MeasureItem( LPMEASUREITEMSTRUCT lpM )
	{		
		//lpM->itemData = (DWORD)"NONE";
		lpM->itemHeight = 23;
		lpM->itemWidth = strlen("About") * 12;
	}

	virtual void DrawItem(LPDRAWITEMSTRUCT lpD)
	{
		CDC* pDC = CDC::FromHandle(lpD->hDC);

		// Draw an yellow background.
		pDC->FillSolidRect(&lpD->rcItem, RGB(255,255,0));

		// If the menu item is selected, draw red
		if( (lpD->itemState & ODS_SELECTED) && (lpD->itemAction & (ODA_SELECT|ODA_DRAWENTIRE)))
		{
			pDC->FillSolidRect(&lpD->rcItem, RGB(255,0,0));
		}

		CMyMenuData* d = (CMyMenuData*)lpD->itemData;
		
		char* pStr  = d->str;
		HICON hIcon = AfxGetApp()->LoadIcon( d->ICON_RESOURCE_ID );
		
		pDC->SetMapMode(MM_TEXT);
		pDC->TextOut( lpD->rcItem.left + 23, lpD->rcItem.top+3, pStr );
		//pDC->DrawIcon( lpD->rcItem.left, lpD->rcItem.top, hIcon);
		DrawIconEx(pDC->m_hDC, lpD->rcItem.left+3, lpD->rcItem.top+3, hIcon, 16, 16, 0, 0, DI_NORMAL);
		
	}
public:

	void AppendMyMenu(UINT Cm_ID, UINT Resource_ID, char* Str)
	{
		//AppendMenu(MF_OWNERDRAW|MF_BYPOSITION , CM_ABOUT, "About");
		m_ItemData[m_NumItems].ID = Cm_ID;
		m_ItemData[m_NumItems].ICON_RESOURCE_ID = Resource_ID;
		strcpy( m_ItemData[m_NumItems].str,  Str);

		AppendMenu(MF_OWNERDRAW|MF_BYPOSITION , Cm_ID, (LPCTSTR)(& (m_ItemData[m_NumItems]) ));

		m_NumItems++;
	}

	void ModifyMyMenu(UINT pos, UINT cm, UINT IDI_ICON, char* str)
	{
		m_ItemData[pos].ID = cm;
		m_ItemData[pos].ICON_RESOURCE_ID = IDI_ICON;
		strcpy( m_ItemData[pos].str, str );

		ModifyMenu(pos+1, MF_OWNERDRAW|MF_BYPOSITION, cm, (LPCTSTR)(& (m_ItemData[pos])) );
	}
		
	//DECLARE_MESSAGE_MAP()
};



